package sun.java2d.pipe.hw;

import java.util.Iterator;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class AccelDeviceEventNotifier
{
    private static AccelDeviceEventNotifier theInstance;
    public static final int DEVICE_RESET = 0;
    public static final int DEVICE_DISPOSED = 1;
    private final Map<AccelDeviceEventListener, Integer> listeners;
    
    private AccelDeviceEventNotifier() {
        this.listeners = Collections.synchronizedMap(new HashMap(1));
    }
    
    private static synchronized AccelDeviceEventNotifier getInstance(boolean b) {
        if (AccelDeviceEventNotifier.theInstance == null && b) {
            AccelDeviceEventNotifier.theInstance = new AccelDeviceEventNotifier();
        }
        return AccelDeviceEventNotifier.theInstance;
    }
    
    public static final void eventOccured(int n, int n2) {
        AccelDeviceEventNotifier instance = getInstance(false);
        if (instance != null) {
            instance.notifyListeners(n2, n);
        }
    }
    
    public static final void addListener(AccelDeviceEventListener accelDeviceEventListener, int n) {
        getInstance(true).add(accelDeviceEventListener, n);
    }
    
    public static final void removeListener(AccelDeviceEventListener accelDeviceEventListener) {
        getInstance(true).remove(accelDeviceEventListener);
    }
    
    private final void add(AccelDeviceEventListener accelDeviceEventListener, int i) {
        this.listeners.put(accelDeviceEventListener, Integer.valueOf(i));
    }
    
    private final void remove(AccelDeviceEventListener accelDeviceEventListener) {
        this.listeners.remove(accelDeviceEventListener);
    }
    
    private final void notifyListeners(int n, int n2) {
        HashMap hashMap;
        synchronized (this.listeners) {
            hashMap = new HashMap(this.listeners);
        }
        for (AccelDeviceEventListener key : hashMap.keySet()) {
            Integer n3 = (Integer)hashMap.get(key);
            if (n3 != null && (int)n3 != n2) {
                continue;
            }
            if (n == 0) {
                key.onDeviceReset();
            }
            else if (n == 1) {
                key.onDeviceDispose();
            }
            else {
                continue;
            }
        }
    }
}
